<style type="text/css" scoped="">




.page_ct{
  display: flex;
  margin-top: 30px;
  margin-bottom: 18px;
  justify-content: center;
}
.base_table{
  margin-top: 20px;
}
</style>
<template>
  <div class="product_list pane_ct">

    <div class="manage_pane_nav">
      <h2 class="manage_pane_nav_title">商品管理</h2>
      <div class="manage_pane_actions">
        <a href="javascript:;" class="action_btn" @click="visible('add_product_form_config', true)">添加公司</a>
      </div>
    </div>

    <!-- <base_dialog></base_dialog> -->

    <div>
      <table class="base_table">
        <tr class="header">
          <td>
            <div class="small_gray_ft">
              商家名称
            </div>
          </td>
          <td>
            <div class="small_gray_ft">
              商家账户
            </div>
          </td>
          <td>
            <div class="small_gray_ft">
              创建时间
            </div>
          </td>
          <td>
            <div class="small_gray_ft">
              状态
            </div>
          </td>
          <td>
            <div class="small_gray_ft">
              操作
            </div>
          </td>
        </tr>

        <tr v-for="item, index in query_configs.data" :key="index">
          <td>
                {{ item.businessName }}  
          </td>
          <td>
              {{ item.userName }}
          </td>
          <td>
              {{ item.time.split('.')[0] }}
          </td>
          <td>
            <span v-if="item.status == 1">已禁用</span>
            <span v-if="item.status == 0">有效</span>
            <span v-if="item.status == 9999">超级账户</span>
          </td>
          <td>
              <div class="td_actions_ct">
                <a class="td_action_btn" href="javascript:;" @click.stop="start_edit(item)">修改账户</a>
                <a class="td_action_btn"  href="javascript:;" @click.stop="forbidden_account(item)" v-if="!item.delete_on_load">
                  <span v-if="item.status == 0">禁用</span>
                  <span v-if="item.status == 1">启用</span>
                </a>
                <a class="td_action_btn" href="javascript:;" @click.stop="start_reset_password(item)">重置密码</a>
                <a class="td_action_btn"  href="javascript:;" v-if="item.delete_on_load">禁用...</a>
              </div>
          </td>
        </tr>
      </table>

      <div class="no_data flex_center" v-if="!query_configs.on_load && !query_configs.data.length">
        当前无记录
      </div>

      <!-- <div class="page_ct">
        <div class="td_action_btn ">上一页</div>
        <div class="td_action_btn base_btn">1</div>
        <div class="td_action_btn base_btn">1</div>
        <div class="td_action_btn blue_aciton_btn">1</div>
        <div class="td_action_btn base_btn">1</div>
        <div class="td_action_btn base_btn">1</div>
        <div class="td_action_btn ">下一页</div>
      </div> -->

      <page_foot 
      :total="query_configs.total_page" 
      :current="query_configs.params.pageNum"
      v-if="query_configs.total_page > 0"
      @select="select"
      ></page_foot>

    </div>

    <add_product_form 
    v-if="add_product_form_config.visible" 
    @close="visible('add_product_form_config', false)"
    @success="edit_item_success"
    ></add_product_form>
    <edit_product_form 
    v-if="edit_product_form_config.visible" 
    v-model="edit_product_form_config.data"
    @success="edit_item_success"
    @close="visible('edit_product_form_config', false)"
    ></edit_product_form>
    <reset_password_form 
    v-if="reset_password_form_config.visible" 
    v-model="reset_password_form_config.data"
    @success="edit_item_success"
    @close="visible('reset_password_form_config', false)"
    ></reset_password_form>
    <!-- reset_password_form -->
  </div>
</template>
<script>
import add_product_form from '@/modules/manage_admin/admins/product_manage/add_product_form.vue'
import edit_product_form from '@/modules/manage_admin/admins/product_manage/edit_product_form.vue'
import reset_password_form from '@/modules/manage_admin/admins/product_manage/reset_password_form.vue'
import img_show_dialog from '@/modules/manage_admin/admins/img_show_dialog.vue'

import page_foot from '@/modules/manage_admin/admins/page_foot.vue'

import {
  company_info,
  query_company_page,
  forbidden_account
} from '@/service'
import {
  get_token
} from '@/modules/stores'
export default {
  data () {
    return {
      add_product_form_config: {
        visible: false
      },

      edit_product_form_config: {
        visible: false,
        data: null
      },

      reset_password_form_config: {
        visible: false,
        data: null
      },

      query_configs: {
        on_load: false,
        total_page: 1,
        params: {
          'pageNum': 1,
        },
        data: [],
        msg: ''
      }
    }
  },
  mounted () {
    this.query();
  },
  methods: {
    visible (config, status){
      this[config].visible = status;
    },
    select (page) {
      this.query_configs.params.pageNum = page;
      this.query();
    },
    async query () {
      await this.query_page();
      let params = JSON.parse(JSON.stringify(this.query_configs.params));
      params.userName = get_token('user_name')

      this.query_configs.on_load = true;

      let data = await company_info(params);
      this.query_configs.data.splice(
        0, 
        this.query_configs.data.length, 
        ...(data.data || [])
      );
      this.query_configs.on_load = false;

      this.query_configs.total_page = data.pageNum;
    },
    async query_page () {
      let data = await query_company_page(this.query_configs.params);
      this.query_configs.total_page = data.pageNum;
    },
    start_edit (item) {
      this.edit_product_form_config.data = item;
      item.oldUserName = item.userName;
      this.visible('edit_product_form_config', true);
    },
    start_reset_password (item) {
      this.reset_password_form_config.data = item;
      this.visible('reset_password_form_config', true);
    },
    async edit_item_success (item) {
      let index = this.query_configs.data.findIndex(i => i.goodsId == item.goodsId);
      if(index > -1){
        this.query_configs.data.splice(index, 1, item);
      }else{
        this.query_configs.data.unshift(item);
      }
      this.clear_dialog();
      await this.query_page();
    },
    clear_dialog () {
      this.visible('edit_product_form_config', false);
      this.visible('add_product_form_config', false);
      this.visible('reset_password_form_config', false);
    },
    async forbidden_account (item) {
      let str = item.status == 0 ? '确定禁用账户' : '确定启用账户';
      let operation_id = item.status == 0 ? 1 : 2;

      let confirm_delete = confirm(str);
      if(!confirm_delete) return ;
      let index = this.query_configs.data.findIndex(i => i.goodsId == item.goodsId);
      item.delete_on_load = true;
      this.query_configs.data.splice(index, 1, item);

      let {errCode, errMsg} = await forbidden_account({businessId: item.businessId, operateTyp: operation_id});
      if(errCode != 200){
        item.delete_on_load = false;
        this.query_configs.data.splice(index, 1, item);
        alert(errMsg);
        return ;
      }
      item.status = item.status == 0 ? 1 : 0;
      item.delete_on_load = false;
      this.query_configs.data.splice(index, 1, item);
    },
    to_sku_manage (item) {
      this.$router.push({
        'name': 'product_sku_manage', 
        params: {
          'goods_id': item.goodsId, 
          'goods_name': item.goodsName, 
          'goods_code': item.goodsCode
        }
      });
    },
    show_img (index, status){
      this.query_configs.data[index].show_img = status;
      let item = this.query_configs.data[index];
      let data = this.query_configs.data.splice(index, 1, item);
    },
    get_bg (url) {
      return {
        'backgroundImage': `url(${url})`
      }
    }
  },
  components: {
    add_product_form,
    edit_product_form,
    reset_password_form,
    img_show_dialog,
    page_foot
  }
}
</script>